// Persistence Of Vision raytracer version 3.0

#version 3.0
global_settings { assumed_gamma 2.2 }
#include "colors.inc"
#include "textures.inc"

camera {
    location <0, 0, -40>
    right <4/3, 0.0, 0.0>
    direction 2*z
    look_at <0, 0, 0>
}

light_source { <10, 15, -30> color White area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}
light_source { <15, -10, -15 > color White area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}
light_source { <-15, -10, -15> color White area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}


#declare CubeSide = box { <2, 0, 2> , <12, -0.2, 12> }

#declare One = polygon { 11, <3,0,10>,<3,0,6>,<9,0,6>,<9,0,4>,<11,0,4>,
                             <11,0,10>,<9,0,10>,<9,0,8>,<5,0,8>,<5,0,10>,
                             <3,0,10>
                             pigment { color Blue } finish { ambient .2 diffuse .6 }
                        }
#declare Two = polygon { 13, <4,0,11>,<4,0,6>,<8,0,6>,<8,0,5>,<4,0,5>
                             <4,0,3>,<10,0,3>,<10,0,8>,<6,0,8>,<6,0,9>
                             <10,0,9>,<10,0,11>,<4,0,11>
                             pigment { color Green } finish { ambient .2 diffuse .6 }
                        }
#declare Five = polygon { 13, <4,0,11>,<4,0,9>,<8,0,9>,<8,0,8>,<4,0,8>
                              <4,0,3>,<10,0,3>,<10,0,5>,<6,0,5>,<6,0,6>
                              <10,0,6>,<10,0,11,>,<4,0,11>
                              pigment { color Yellow } finish { ambient .2 diffuse .6 }
                        }
#declare Six = polygon { 14, <3,0,10>,<3,0,4>,<11,0,4>,<11,0,10>,<9,0,10>
                             <9,0,6>,<8,0,6>,<8,0,10>,<3,0,10>
                             <5,0,8>,<5,0,6>,<6,0,6>,<6,0,8>,<5,0,8>
                             pigment { color Cyan } finish { ambient .2 diffuse .6 }
                       }
#declare Three = polygon { 13, <3,0,10>,<3,0,4>,<5,0,4>,<5,0,8>,<6,0,8>
                               <6,0,4>,<8,0,4>,<8,0,8>,<9,0,8>,<9,0,4>
                               <11,0,4>,<11,0,10>,<3,0,10>
                               pigment {color Red } finish { ambient .2 diffuse .6 }
                         }
#declare Four = union { polygon { 10, <2.5,0,6.5>,<3,0,6>,<4,0,7>,<3,0,7>,<2.5,0,6.5>
                                      <4,0,8>,<5,0,8>,<7,0,10>,<7,0,11>,<4,0,8>
                                      pigment { color Yellow } finish { ambient .2 diffuse .6 }
                                }
                        polygon { 5, <3,0,6>,<10,0,6>,<10,0,7>,<4,0,7>,<3,0,6>
                                     pigment { color Red } finish { ambient .2 diffuse .6 }
                                }
                        polygon { 10, <7,0,6>,<7,0,4>,<8,0,4>,<8,0,6>,<7,0,6>
                                      <7,0,11>,<7,0,7>,<8,0,7>,<8,0,11>,<7,0,11>
                                      pigment { color Green } finish { ambient .2 diffuse .6 }
                                }
                        polygon { 10, <10,0,7>,<10,0,5>,<11,0,5>,<11,0,7>,<10,0,7>
                                      <10,0,9>,<10,0,8>,<11,0,8>,<11,0,9>,<10,0,9>
                                      pigment { color Magenta } finish { ambient .2 diffuse .6 }
                                }
                        polygon { 10, <4,0,8>,<3,0,7>,<7,0,7>,<7,0,8>,<4,0,8>
                                      <8,0,8>,<8,0,7>,<11,0,7>,<11,0,8>,<8,0,8>
                                      pigment { color Blue } finish { ambient .2 diffuse .6 }
                                }
                       }
#declare SideThree = union {object { CubeSide texture { pigment { Yellow }  finish { ambient .2 diffuse .6 } } }
                            object { Three translate <0, 0.2, 0> }
                            object { Three translate <0, -0.4, 0> }
                           }
#declare SideSix = union {object { CubeSide texture { pigment { Magenta }  finish { ambient .2 diffuse .6 } } }
                          object { Six translate <0, 0.2, 0> }
                          object { Six translate <0, -0.4, 0> }
                         }
union {
union { object {SideThree rotate <0,0,90> translate <14, 0, 0 > }
        object {SideSix }
        rotate <0,0,90>
        translate <7, 0, -7 >
      }
union { object { CubeSide
      texture { pigment { Blue }  finish { ambient .2 diffuse .6 } } translate <0,0,-14>}
      object { Two translate <0, 0.2, -14> }
      object { Two translate <0, -0.4, -14> }
      rotate <90,0,0>
      translate <-7, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Red }  finish { ambient .2 diffuse .6 } } }
      object { Five translate <0, 0.2, 0> }
      object { Five translate <0, -0.4, 0> }
      rotate <-90,0,0>
      translate <-7, 0, 7 >
     }
union { object { CubeSide
      texture { pigment { Green } finish { ambient .2 diffuse .6 } } translate <-14,0,0>}
      object { One translate <-14, 0.2, 0> }
      object { One translate <-14, -0.4, 0> }
      rotate <0,0,-90>
      translate <-7, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Gray50 }  finish { ambient .2 diffuse .6 } } }
      object { Four translate <0, -0.4, 0> }
      translate <-7, 0, -7 >
     }
     rotate < 0, -90, 0 >
     translate < 0, -7 , 0 >
     rotate <0,-360 * clock,0>
     rotate <-40 * sin(pi*clock),0,0>
}
